from datetime import datetime
from collections import namedtuple

CampaignInfo = namedtuple('CampaignInfo', 'startday agemin agemax region coverage label')

def ConstructHistoricalCampaigns():
    """
    Building historical campaign calendar by hand from the WHO calendar, rather than trying to process that file, which has a
    free-form "comment field" with important info.  Coverages from scenario files.  Ignoring mopup and OBR, including the large OBR in NE in Jan 2017
    Format (date, minimum age target, maximum age target, target region, target coverage, SIA ID)
    """
    historical_campaign_calendar = [CampaignInfo(datetime.strptime('12/06/2005', '%m/%d/%Y'), 0.75, 15, 'north', 0.68, 0),
                                    CampaignInfo(datetime.strptime('10/03/2006', '%m/%d/%Y'), 0.75, 15, 'south', 0.68, 0),
                                    CampaignInfo(datetime.strptime('11/26/2008', '%m/%d/%Y'), 0.75, 5,  'all', 0.73, 1),
                                    CampaignInfo(datetime.strptime('01/26/2011', '%m/%d/%Y'), 0.75, 5,  'all', 0.75, 2),
                                    CampaignInfo(datetime.strptime('10/05/2013', '%m/%d/%Y'), 0.75, 5,  'north', 0.78, 3),
                                    CampaignInfo(datetime.strptime('11/02/2013', '%m/%d/%Y'), 0.75, 5,  'south', 0.78, 3),
                                    CampaignInfo(datetime.strptime('11/21/2015', '%m/%d/%Y'), 0.75, 10, 'north', 0.84, 4),
                                    CampaignInfo(datetime.strptime('01/28/2016', '%m/%d/%Y'), 0.75, 5,  'south', 0.84, 4),
                                    CampaignInfo(datetime.strptime('10/15/2017', '%m/%d/%Y'), 0.75, 5,  'north', 0.88, 5),
                                    CampaignInfo(datetime.strptime('02/15/2018', '%m/%d/%Y'), 0.75, 5,  'south', 0.88, 5)]

    return historical_campaign_calendar

