import coverage
import unittest
loader = unittest.TestLoader()
cov = coverage.Coverage(source=[
    "emodpy_measles.interventions.complex_import"
    , "emodpy_measles.interventions.measles_vaccine"
    , "emodpy_measles.interventions.simple_sia"
    , "emodpy_measles.interventions.targeted_outbreak"
])
cov.start()

# First, load and run the unittest tests
from test_camp_interventions import TestCampInterventions

test_classes_to_run = [TestCampInterventions]

suites_list = []
for tc in test_classes_to_run:
    suite = loader.loadTestsFromTestCase(tc)
    suites_list.append(suite)
    pass

big_suite = unittest.TestSuite(suites_list)
runner = unittest.TextTestRunner()
results = runner.run(big_suite)

cov.stop()
cov.save()
cov.html_report()