import unittest

class EmodpyMeaslesImportTest(unittest.TestCase):
    def setUp(self) -> None:
        self.expected_items = None
        self.found_items = None
        pass

    def verify_expected_items_present(self, namespace):
        self.found_items = dir(namespace)
        for item in self.expected_items:
            self.assertIn(
                item,
                self.found_items
            )

    def tearDown(self) -> None:
        pass

    def test_package_emodpy_measles(self):
        self.expected_items = [
            "CampaignInfo",
            "ConstructHistoricalCampaign"
        ]

    def test_module_interventions_complex_import(self):
        from emodpy_measles.interventions import complex_import
        self.expected_items = [
            "ComplexImportationEvent"
        ]

        self.verify_expected_items_present(namespace=complex_import)
        pass

    def test_module_interventions_measles_vaccine(self):
        from emodpy_measles.interventions import measles_vaccine
        self.expected_items = [
            "SimpleMCV1",
            "SimpleMCV2"
        ]

        self.verify_expected_items_present(namespace=measles_vaccine)
        pass

    def test_module_interventions_simple_sia(self):
        from emodpy_measles.interventions import simple_sia
        self.expected_items = [
            "SimpleSIA"
        ]

        self.verify_expected_items_present(namespace=simple_sia)
        pass

